/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TOptions.h
#ifndef _CYR_TOPTIONS_H
#define _CYR_TOPTIONS_H
/**
 * Class definition for rule defining an option holder
 * This is basically an abstraction of on a map.
 *
 **/
#ifdef WIN32
#pragma warning(disable:4786)
#endif

#include <string>
#include <map>

using namespace std;
class TOptions;
ostream& operator <<(ostream&,const TOptions&);

#ifdef UNIX
#elif defined (__VMS)
#elif defined (WIN32)
#else //unknown
#error Unknown Platform
#endif // unknown

// local includes
#include "AtvfKey.h"

// type defintion for container to hold these options
#ifdef __VAX
typedef map<AtvfKey, string*, less<AtvfKey> > topt_cont_t;
#else
typedef map<AtvfKey, const string*, less<AtvfKey> > topt_cont_t;
#endif

class TOptions
{
    topt_cont_t _opts;
public:
    // constructors & destructor
    TOptions();
    TOptions(const TOptions& options);
    virtual ~TOptions();

    // accessors
    string value(const string& key) const;
    bool exists(const string& key) const;
    bool empty() const;

    // mutators
    void add(const string& text);
    void add(const TOptions& text);

    // friend operators
    friend ostream& operator <<(ostream& os,const TOptions& top);
private:
    operator=(const TOptions&);
}
; // TOptions

#endif // _CYR_TOPTIONS_H
