/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TScriptHead.h
#ifndef _CYR_TSCRIPTHEAD_H
#define _CYR_TSCRIPTHEAD_H
/**
 * Object to represent the header info of a transaction script 
 **/
#ifdef WIN32
#pragma warning(disable:4786)
#endif
#include <string>
#ifdef unix
#elif defined (__VMS)
#elif defined (WIN32)
using namespace std;
#else //unknown
#error Unknown Platform
#endif // unknown

// Local includes
#include "AtvfRule.h"
#include "TPrmRealRules.h"
#include "TParam.h"
#include "TRecord.h"

// class definition
class TScriptHead : public TRecord
{
    string* _verP;

public:
    // construtors & destructor
    TScriptHead(TParamRule* = NULL);
    virtual ~TScriptHead();

    // accessors
    string version() const;
    virtual string description() const;
    virtual bool isKnown() const;

    // mutators
    virtual void setVer(string* verP);
private:
    TScriptHead(const TScriptHead&);
    operator=(const TScriptHead&);
}
; // TScriptHead
#endif // CYR_TSCRIPTHEAD_H
