/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// Result set class
//

#ifndef RESSET_H
#define RESSET_H

#include "rescol.h"

#define COLFAC  32              // Column array allocation factor

class Cresultset
{

public:

    // Constructor/Destructor
    Cresultset();
    virtual	~Cresultset();

    // Public member functions
    int         addcol(char * name, int width);
    char *      getcolname(int col);
    int         getcolwidth(int col);
    int         getcoldwidth(int col);
    int         gettotalwidth(void);
    int         getnrows(void);
    int         getncols(void);
    char *      nextcoladdr(int col);
    char *      getresdata(int row, int col);
    int         fetched_rows(int rows);

    // Public variables
public:

    // Protected variables
protected:

    Cresultcol  **cols;         // Column array
    int         colarrsz;       // Allocated size of column array
    int         ncols;          // Number of columns in result set
    int         fetch_count;    // Number of rows fetched

private:
    //// Forbidden:
    Cresultset(const Cresultset&);
    operator=(const Cresultset&);
}
;

#endif  // RESSET_H
