/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// CECSpinEditCell.h: interface for the CECSpinEditCell class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CECSPINEDITCELL_H__26BAB114_AA78_11D4_94B7_00C04F89E392__INCLUDED_)
#define AFX_CECSPINEDITCELL_H__26BAB114_AA78_11D4_94B7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GridBtnCell.h"

class CECSpinEditCell : public CGridBtnCell  
{
public:
	CECSpinEditCell();
	DECLARE_DYNCREATE(CECSpinEditCell);

	virtual ~CECSpinEditCell();
	void SetNumberOnly(bool bSet);
	BOOL Edit(int nRow, int nCol, CRect rect, CPoint point, UINT nID, UINT nChar);
	void SetRange(int nMin,int nMax);
    virtual void SetText(LPCTSTR szText);

private:
	bool m_bNumberOnly;
	int m_nMaxValue;
	int m_nMinValue;
};

#endif // !defined(AFX_CECSPINEDITCELL_H__26BAB114_AA78_11D4_94B7_00C04F89E392__INCLUDED_)
