/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// HostDefDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestPlugin.h"
#include "HostDefDlg.h"
#include "TestFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHostDefDlg dialog


CHostDefDlg::CHostDefDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHostDefDlg::IDD, pParent),
	m_pTestFile(NULL)
{
	//{{AFX_DATA_INIT(CHostDefDlg)
	m_strHostName = _T("");
	//}}AFX_DATA_INIT
}


void CHostDefDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostDefDlg)
	DDX_Control(pDX, IDC_HOST_COMBO, m_ctlHostCombo);
	DDX_CBString(pDX, IDC_HOST_COMBO, m_strHostName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHostDefDlg, CDialog)
	//{{AFX_MSG_MAP(CHostDefDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHostDefDlg message handlers

void CHostDefDlg::OnOK() 
{
	UpdateData();

	if(m_strHostName.IsEmpty())
	{
		AfxMessageBox("Please enter a host name");
		return;
	}
	
	m_strHostName.MakeUpper();
	CDialog::OnOK();
}

BOOL CHostDefDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
		
	if(m_pTestFile)
	{
		m_ctlHostCombo.SetRedraw(FALSE);
		int nNumGroups = m_pTestFile->GetNumTaskGroups();
		for(int nGroup=0;nGroup<nNumGroups;nGroup++)
		{
			CString strHost = m_pTestFile->GetTaskGroupHost(nGroup);
			if(m_ctlHostCombo.FindStringExact(-1,strHost)==CB_ERR)
				m_ctlHostCombo.AddString(strHost);
		}
		m_ctlHostCombo.SetRedraw();
	}

	m_ctlHostCombo.SelectString(-1,m_strHostName);

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
