/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include "stdafx.h"
#include <iostream>
using std::cout;
using std::endl;

extern HHOOK hh ;
extern char gzCertName[128] ; 

BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam)
{
    char zClass[128];

	gzCertName[0] = 0 ;
    GetClassName(hWnd, zClass, sizeof(zClass) / sizeof(zClass[0]));
    if(lstrcmp(zClass, "ListBox") == 0)
    {
        // Retrieve the selected text.
        int iCur = SendMessage(hWnd, LB_GETCURSEL, 0, 0);
        if(iCur != LB_ERR)
        {
			
			SendMessage(hWnd, LB_GETTEXT, (WPARAM)iCur, (LPARAM)gzCertName);
        }

        return FALSE;   // Stop enumerating.
    }

    return TRUE;
}


LRESULT CALLBACK CallWndProc(
    int code,       // hook code
    WPARAM wParam,  // not used
    LPARAM lParam   // message data
    )
{
    CWPSTRUCT* ps = (CWPSTRUCT*)lParam;
    if(ps->message == WM_COMMAND && HIWORD(ps->wParam) == 0 && LOWORD(ps->wParam) == 1)
    {
        // Verify we are in the Client Authentication dialog.
        char zClass[128];
        GetClassName(ps->hwnd, zClass, sizeof(zClass) / sizeof(zClass[0]));
        if(lstrcmp(zClass, "#32770") == 0)
        {
            // Find the list box.
            EnumChildWindows(ps->hwnd, EnumChildProc, 0);
        }

        // IDOK was sent.
    }
    return CallNextHookEx(hh, code, wParam, lParam);
}

