#ifndef __CONSTANTESLIB_H__
#define __CONSTANTESLIB_H__
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


//Default menu for the standard editor



//Registry index for preferences
#define ID_COLOR_PREFERENCE     1
#define ID_INDENT_PREFERENCE    2
#define ID_FONT_PREFERENCE      3
#define ID_CAPTURE              4
#define ID_PROXY_LOCAL          5
#define ID_PROXY_REMOTE         6
#define ID_VARIABLE             7

//keyword array in the edit control
#define MY_KEYWORDARRAYSIZE 10000

//Repository constantes
#define STR_REPOSITORY_SEPARATOR   "|"
#define STR_REPOSITORY_CAPTURE     "Capture"
#define STR_REPOSITORY_DATA        "Data"
#define STR_REPOSITORY_INCLUDE     "RESPONSE_CODES.INC"
#define STR_REPOSITORY_GLOBALVAR   "GLOBAL_VARIABLES.INC"
#define STR_SCL_EXTENSION         ".HTP"
#define STR_TOF_EXTENSION         ".TOF"
#define STR_ALL_EXTENSION         ".ALL"
#define STR_FVR_EXTENSION         ".FVR"
#define STR_INC_EXTENSION         ".INC"

#define WM_CARET_POS_CHANGED    (WM_APP+3)

//Variables constantes
#define VAR_SCOPE_PRIVATE  1
#define VAR_SCOPE_LOCAL    2
#define VAR_SCOPE_SCRIPT   3
#define VAR_SCOPE_THREAD   4
#define VAR_SCOPE_GLOBAL   5

#define VAR_SOURCE_LIST       1
#define VAR_SOURCE_FILE       2
#define VAR_SOURCE_HTML       3
#define VAR_SOURCE_DATABASE   4

#define VAR_ORDER_SEQUENTIAL  1
#define VAR_ORDER_RANDOM      2

#define VAR_DATATYPE_CHAR  1
#define VAR_DATATYPE_INT   2

#define VAR_DBSOURCE_TABLE      1
#define VAR_DBSOURCE_REQUEST    2

#define VAR_ROWSEL_ALL      1
#define VAR_ROWSEL_SOME     2

//Browser constantes
#define ID_BROWSER_NONE     0
#define ID_BROWSER_IE4      1
#define ID_BROWSER_IE5      2
#define ID_BROWSER_NS47     3
#define ID_BROWSER_NS6      4

#define STR_BROWSER_IE4     "!Browser:IE4"
#define STR_BROWSER_IE5     "!Browser:IE5"
#define STR_BROWSER_NS47    "!Browser:NETSCAPE 4.7"
#define STR_BROWSER_NS6     "!Browser:NETSCAPE 6"

#define STR_ERROR           "error"
#define STR_MODELLER_IE4    "ModelerIE4.txt"
#define STR_MODELLER_IE5    "ModelerIE5.txt"
#define STR_MODELLER_NS47   "ModelerNS47.txt"

#define STR_FULLNAME_BROWSER_IE4     "Microsoft Internet Explorer 4"
#define STR_FULLNAME_BROWSER_IE5     "Microsoft Internet Explorer 5"
#define STR_FULLNAME_BROWSER_NS47    "Netscape Communicator 4.7"
#define STR_FULLNAME_BROWSER_NS6     "Netscape Communicator 6"

#define STR_IE4_FIRSTVERSION    "4.71.544"
#define STR_IE4_COMPATPATH      "\\- 4 Compatible\\IE4.exe"
#define STR_IE5_FIRSTVERSION    "5.00.0518.10"

#define STR_NS47_VERSION        "4.7"

#define STR_REGISTRY_SEPARATOR      "%"

// Misc
#define ID_NONE             -1
#define ID_LOCALHOST_SIZE   100
#define STR_MODELLER_KEY        "SOFTWARE\\OpenSTA\\Modeler"
#define STR_MODELLER_KEY_GENERAL "SOFTWARE\\OpenSTA\\Modeler\\General"
#define STR_MODELLER_KEY_GATEWAY "SOFTWARE\\OpenSTA\\Modeler\\Gateway"
#define STR_MDL_NETSCAPE_ENTRY  "NetscapeSettingsPath"

#endif
