#if !defined(AFX_EXTENDEDPROPERTYPAGE_H__E7FEE8D5_6637_11D1_9E28_0020AFAC7193__INCLUDED_)
#define AFX_EXTENDEDPROPERTYPAGE_H__E7FEE8D5_6637_11D1_9E28_0020AFAC7193__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ExtendedPropertyPage.h : header file
//
class CExtendedPropertySheet;

/////////////////////////////////////////////////////////////////////////////
// CExtendedPropertyPage
/////////////////////////////////////////////////////////////////////////////
class CExtendedPropertyPage : public CPropertyPage
{
    DECLARE_DYNCREATE(CExtendedPropertyPage)

    //Attributes
protected:
    BOOL                    m_bEnabled;
    CExtendedPropertySheet* m_pPropSheet;
public:
    BOOL                    m_bActivated;

    //Operations
protected:
    BOOL            Enable(BOOL bEnable=TRUE);
    BOOL            IsEnabled(void);
    virtual LRESULT GetNextPage(BOOL forward = TRUE);

    friend class CExtendedPropertySheet;

    //Construction
public:
    CExtendedPropertyPage   (UINT nIDTemplate, UINT nIDCaption = 0);
    CExtendedPropertyPage   (LPCTSTR lpszTemplateName, UINT nIDCaption = 0);
    CExtendedPropertyPage   ();
    ~CExtendedPropertyPage  ();

    virtual void Values2Ctrl() ;
    virtual void Ctrl2Values() ;
    virtual BOOL Verify() ;
    virtual BOOL Modify() ;
    virtual void DisplayErrorMessage() ;
    BOOL SaveValues() ;

    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CExtendedPropertyPage)
    virtual BOOL OnSetActive();
    virtual BOOL OnKillActive();
    virtual LRESULT OnWizardNext();
    virtual LRESULT OnWizardBack();
    virtual BOOL OnWizardFinish();
    virtual void OnCancel();
    virtual void OnOK();
    virtual BOOL OnApply() ;
    virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
    //}}AFX_VIRTUAL
}
;

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXTENDEDPROPERTYPAGE_H__E7FEE8D5_6637_11D1_9E28_0020AFAC7193__INCLUDED_)
