/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// RecovererDlg.cpp : implementation file
//

#include "stdafx.h"
#include "concertlib.h"
#include "RecovererDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecovererDlg dialog

BEGIN_MESSAGE_MAP(CRecovererDlg, CDialog)
//{{AFX_MSG_MAP(CRecovererDlg)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//------------------------------------------------------------------------------------

CRecovererDlg::CRecovererDlg(CWnd* _pParent /*=NULL*/,
                             CString _strBrowserName,
                             BOOL * _pbDeleteOld )
        : CDialog(CRecovererDlg::IDD, _pParent)
{
    //{{AFX_DATA_INIT(CRecovererDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT

    m_strBrowserName    = _strBrowserName ;
    m_pbDeleteOld       = _pbDeleteOld ;
}

//------------------------------------------------------------------------------------

BOOL CRecovererDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    CWnd *     pEdit ;
    CButton *   pButton ;
    //---

    pEdit = static_cast<CWnd *>( GetDlgItem( IDC_BROWSER_NAME ) ) ;
    pEdit->SetWindowText( m_strBrowserName ) ;

    pButton = static_cast<CButton *>( GetDlgItem( IDC_DELETEOLD ) ) ;
    pButton->SetCheck( 1 ) ;

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

//------------------------------------------------------------------------------------


void CRecovererDlg::OnOK()
{
    CButton *pButton ;
    //---
    pButton = static_cast< CButton*>( GetDlgItem( IDC_DELETEOLD ) );

    *m_pbDeleteOld = pButton->GetCheck() ;

    CDialog::OnOK();
}
