// ScriptMonDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ScriptMonDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern HINSTANCE m_hInstance;

#define ID_POLL_DATA 1
/////////////////////////////////////////////////////////////////////////////
// CScriptMonDlg dialog


CScriptMonDlg::CScriptMonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScriptMonDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScriptMonDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pCmd = NULL;
}


void CScriptMonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScriptMonDlg)
	DDX_Control(pDX, IDC_LIST, m_ctlList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScriptMonDlg, CDialog)
	//{{AFX_MSG_MAP(CScriptMonDlg)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptMonDlg message handlers
BOOL CScriptMonDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowText(m_TaskName);

	SetIcon(LoadIcon( m_hInstance, MAKEINTRESOURCE(IDI_MONITOR)), FALSE);

	CRect r;
	GetClientRect(r);
	m_ctlList.InsertColumn(0,"VU ID",LVCFMT_LEFT, r.Width()/5);
	m_ctlList.InsertColumn(1,"Script Name",LVCFMT_LEFT, r.Width()/5);
	m_ctlList.InsertColumn(2,"Node",LVCFMT_LEFT, r.Width()/5);
	m_ctlList.InsertColumn(3,"Note Text",LVCFMT_LEFT, r.Width()/5);
	m_ctlList.InsertColumn(4,"Start Time",LVCFMT_LEFT, r.Width()/5);
	
	UpdateList();
	SetTimer(ID_POLL_DATA, 5000, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CScriptMonDlg::InitMonitor(CString strRunPath, CString strTaskName, CString strManagerReg)
{
	m_TaskName = strTaskName;
	strManagerReg.TrimRight(" \r\n");

	CString enginesPath = getenv("OPENSTA_HOME");
	enginesPath += "Engines";

	SetCurrentDirectory(enginesPath);

	CString cmd = "TestInfo.exe -M -I " + strManagerReg + " -O TI_"+m_TaskName+".TXT -R 5";
	m_pCmd = new CCmdExec(cmd);
	CString strInfoPath = enginesPath+"\\TI_"+m_TaskName+".TXT";

	m_pCmd->Execute();
	try
	{
		Sleep(1000);
		m_outFile.Open(strInfoPath, CFile::modeRead | CFile::typeText | CFile::shareDenyNone);
		m_outFile.SeekToEnd();
	}
	catch(...)
	{
		LPVOID lpMsgBuf;
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);
		// Process any inserts in lpMsgBuf.
		// ...
		// Display the string.
		MessageBox( (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );
	}
}

void CScriptMonDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (m_ctlList.m_hWnd != NULL)
	{
		m_ctlList.MoveWindow(0,0,cx,cy);
	}
}

void CScriptMonDlg::OnTimer(UINT nIDEvent) 
{
	UpdateList();
	
	CDialog::OnTimer(nIDEvent);
}

void CScriptMonDlg::UpdateList()
{
	m_ctlList.DeleteAllItems();

	CString line;
	int i =0;
	while (m_outFile.ReadString(line))
	{
		CString id, script, node, text, time;
		GetNextField(',',line,id);
		GetNextField(',',line,script);
		GetNextField(',',line,node);
		GetNextField(',',line,text);
		GetNextField(',',line,time);

		if (script==m_TaskName)
		{
			m_ctlList.InsertItem(i, id);
			m_ctlList.SetItemText(i,1,script);
			m_ctlList.SetItemText(i,2,node);
			m_ctlList.SetItemText(i,3,text);
			m_ctlList.SetItemText(i,4,time);
			i++;
		}
	}
}

int CScriptMonDlg::GetNextField(char sep, CString &inStr, CString &field)
{
    if (inStr == "")
    {
        return -1;
    }

    int len = inStr.GetLength();
    int nPos = inStr.Find(sep, 0);

    if (nPos == -1)
    {
        field = inStr;
        inStr = "";
        return 0;
    }
    else
    {
        field = inStr.Left(nPos);
        inStr = inStr.Right(len - nPos - 1);
        return 0;
    }
}

void CScriptMonDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	if (m_pCmd != NULL)
	{
		m_pCmd->KillProcess();
		delete m_pCmd;
	}
}