// ScriptSummary.cpp : implementation file
//

#include "stdafx.h"
#include "ScriptSummary.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define IDT_POLL_DATA 1

/////////////////////////////////////////////////////////////////////////////
// CScriptSummary dialog


CScriptSummary::CScriptSummary(CWnd* pParent /*=NULL*/)
	: CDialog(CScriptSummary::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScriptSummary)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pCmd = NULL;
}


void CScriptSummary::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScriptSummary)
	DDX_Control(pDX, IDC_SCRIPTLIST, m_ctlScriptList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScriptSummary, CDialog)
	//{{AFX_MSG_MAP(CScriptSummary)
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptSummary message handlers

BOOL CScriptSummary::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CRect rc;
	GetClientRect(rc);
	m_ctlScriptList.InsertColumn( 0,"Script Name", LVCFMT_LEFT, rc.Width()/2);
	m_ctlScriptList.InsertColumn(1,"VU Count", LVCFMT_LEFT, rc.Width()/2);

	for (int i = 0; i<m_arrTasks.GetSize(); i++)
	{
		m_ctlScriptList.InsertItem(i,m_arrTasks.GetAt(i));
		m_ctlScriptList.SetItemText(i,1,"0");

	}

	SetTimer(IDT_POLL_DATA, 5000, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CScriptSummary::InitMonitor(CString strTaskGroup,CStringArray& arrTasks , CString strManagerReg)
{
	for (int i = 0; i<arrTasks.GetSize(); i++)
	{
		m_arrTasks.Add(arrTasks.GetAt(i));
	}

	try
	{
		strManagerReg.TrimRight(" \r\n");

		CString enginesPath = getenv("OPENSTA_HOME");
		enginesPath += "Engines";

		SetCurrentDirectory(enginesPath);
		CString strSubTest = strTaskGroup;
		strSubTest.MakeUpper();
		CString cmd = "TestInfo.exe -E -I " + strManagerReg + " -O TI_SCR_SUMMARY.TXT -T "+ strSubTest;
		m_pCmd = new CCmdExec(cmd);
		CString strInfoPath = enginesPath+"\\TI_SCR_SUMMARY.TXT";

		m_pCmd->Execute();
		Sleep(1000);
		m_outFile.Open(strInfoPath, CFile::modeRead | CFile::typeText | CFile::shareDenyNone);
		m_outFile.SeekToEnd();
	}
	catch(...)
	{
		LPVOID lpMsgBuf;
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);
		// Process any inserts in lpMsgBuf.
		// ...
		// Display the string.
		MessageBox( (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );
	}
}

void CScriptSummary::OnTimer(UINT nIDEvent) 
{
	for (int i = 0; i<m_ctlScriptList.GetItemCount(); i++)
	{
		m_ctlScriptList.SetItemText(i,1,"0");
	}

	CString line;
	while (m_outFile.ReadString(line))
	{
		CString script, count;
		GetNextField(',',line,script);
		GetNextField(',',line,count);

		for (int i = 0; i<m_ctlScriptList.GetItemCount(); i++)
		{
			if (m_ctlScriptList.GetItemText(i, 0) == script)
			{
				m_ctlScriptList.SetItemText(i,1,count);
			}
		}
	}	
	CDialog::OnTimer(nIDEvent);
}

int CScriptSummary::GetNextField(char sep, CString &inStr, CString &field)
{
    if (inStr == "")
    {
        return -1;
    }

    int len = inStr.GetLength();
    int nPos = inStr.Find(sep, 0);

    if (nPos == -1)
    {
        field = inStr;
        inStr = "";
        return 0;
    }
    else
    {
        field = inStr.Left(nPos);
        inStr = inStr.Right(len - nPos - 1);
        return 0;
    }
}

void CScriptSummary::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if(m_ctlScriptList.m_hWnd != NULL)
	{
		m_ctlScriptList.MoveWindow(0,0,cx,cy);
	}
	
}

void CScriptSummary::OnDestroy() 
{
	CDialog::OnDestroy();	
	if (m_pCmd != NULL)
	{
		m_pCmd->KillProcess();
		delete m_pCmd;
	}
}
