/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// FilterURLDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FilterURLDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFilterURLDlg dialog


CFilterURLDlg::CFilterURLDlg(URLMap* pmapUrls,
                             CDWordArray& ardwSelectedURLs,
                             CWnd* pParent /*=NULL*/)
        : CDialog(CFilterURLDlg::IDD, pParent),
        m_ardwSelectedURLs(ardwSelectedURLs)

{
	m_pmapUrls = pmapUrls;
    //{{AFX_DATA_INIT(CFilterURLDlg)
    //}}AFX_DATA_INIT
    m_szHtmlHelpFile = getenv("OPENSTA_HOME");
    m_szHtmlHelpFile += "\\Framework\\Help\\Commander.chm";
}


void CFilterURLDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CFilterURLDlg)
    DDX_Control(pDX, IDC_URL_LIST, m_ctlURLList);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CFilterURLDlg, CDialog)
//{{AFX_MSG_MAP(CFilterURLDlg)
ON_BN_CLICKED(IDC_SELECT_ALL, OnSelectAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFilterURLDlg message handlers

BOOL CFilterURLDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    m_ctlURLList.SetRedraw(FALSE);
    m_ctlURLList.InitStorage(m_pmapUrls->GetCount(),50);

    //Add all the available URLs to the list box
    int nIndex=0;
	CString strItem;
	int nStat;
	POSITION pos = m_pmapUrls->GetStartPosition();
	while(pos)
	{
		m_pmapUrls->GetNextAssoc(pos,strItem,nStat);

        nIndex = m_ctlURLList.FindStringExact(-1,strItem);
        if(nIndex == LB_ERR)
            m_ctlURLList.AddString(strItem);
    }

    int nNumItems = m_ctlURLList.GetCount();
    if(m_ardwSelectedURLs.GetSize())
    {
        //Select the Desired items
        for(int nItem=0;nItem<m_ardwSelectedURLs.GetSize();nItem++)
        {
            if(nNumItems>(int)m_ardwSelectedURLs[nItem])
                m_ctlURLList.SetSel(m_ardwSelectedURLs[nItem]);
        }
    }
    else
    {
        //No selected items is equivalent to all selected
        int nNumItems = m_ctlURLList.GetCount();
        for(int nItem=0;nItem<nNumItems;nItem++)
            m_ctlURLList.SetSel(nItem);
    }

    m_ctlURLList.SetRedraw();

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


void CFilterURLDlg::OnSelectAll()
{
    m_ctlURLList.SetRedraw(FALSE);
    int nNumItems = m_ctlURLList.GetCount();
    for(int nItem=0;nItem<nNumItems;nItem++)
    {
        m_ctlURLList.SetSel(nItem);
    }
    m_ctlURLList.SetRedraw();
}


void CFilterURLDlg::OnOK()
{
    m_ardwSelectedURLs.RemoveAll();

    int nSelCount = m_ctlURLList.GetSelCount();
    int nNumItems = m_ctlURLList.GetCount();

    if(nSelCount!=nNumItems)
    {
        CString strItem;
        for(int nItem=0;nItem<nNumItems;nItem++)
        {
            if(m_ctlURLList.GetSel(nItem) > 0)
                m_ardwSelectedURLs.Add(nItem);
        }
    }

    CDialog::OnOK();
}

