#if !defined(AFX_PREFERENCESMODELLERGATEWAYPPAGE_H__8C728573_F42F_11D3_AC83_00105A483E3C__INCLUDED_)
#define AFX_PREFERENCESMODELLERGATEWAYPPAGE_H__8C728573_F42F_11D3_AC83_00105A483E3C__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GatewayOptionsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGatewayOptionsDlg dialog
#include "resource.h"
#include "EnumData.h"

class CGatewayOptionsDlg : public CDialog
{
    DECLARE_DYNCREATE(CGatewayOptionsDlg)

    _TPreferencesGatewayData        *m_pData ;
    BOOL                            m_bModified ;

    CEdit                           m_IPEditAddress;
    CEdit                           m_IPEditSecure;

    // Construction
public:
    CGatewayOptionsDlg(_TPreferencesGatewayData* pData = NULL );
    ~CGatewayOptionsDlg();


    void InitLocalProxy();
    void InitRemoteProxy();
    void SaveRemoteProxy();

    // Dialog Data
    //{{AFX_DATA(CGatewayOptionsDlg)
	enum { IDD = IDD_GATEWAY_OPTIONS_DLG };
    BOOL    m_bConsole;
    BOOL    m_bTrace;
	BOOL	m_bAutoCookieCheck;
	//}}AFX_DATA


    // Overrides
    // ClassWizard generate virtual function overrides
    //{{AFX_VIRTUAL(CGatewayOptionsDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CGatewayOptionsDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnCheckBypass();
    afx_msg void OnChangeEditAddress();
    afx_msg void OnChangeEditAddressNoproxy();
    afx_msg void OnChangeEditAddressPort();
    afx_msg void OnChangeEditAdminPort();
    afx_msg void OnChangeEditSecure();
    afx_msg void OnChangeEditSecurePort();
    afx_msg void OnRadioLocal();
    afx_msg void OnRadioRemote();
    afx_msg void OnChangeEditPort();
    virtual void OnOK();
    afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PREFERENCESMODELLERGATEWAYPPAGE_H__8C728573_F42F_11D3_AC83_00105A483E3C__INCLUDED_)
