/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// OSModellerEditCtrl.cpp: implementation of the COSModellerEditCtrl class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Solutions.h"
#include "modeller.h"
#include "OSModellerEditCtrl.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include <ConstantesLib.h>

//-----------------------------------------------------------------------

BEGIN_MESSAGE_MAP(COSModellerEditCtrl, COSWebEditCtrl )
//{{AFX_MSG_MAP(COSModellerEditCtrl)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

COSModellerEditCtrl::COSModellerEditCtrl(LPCSTR pczRegistryPath /*= NULL*/)
        :   COSWebEditCtrl( pczRegistryPath )
{}


COSModellerEditCtrl::~COSModellerEditCtrl()
{
}

//-----------------------------------------------------------------------


void COSModellerEditCtrl::InitKeywords()
{
    COSWebEditCtrl::InitKeywords() ;

    TCHAR *pczBuffer = _T("GET\nPOST\nHEAD\nCONNECT\nDISCONNECT\n"
                          "SYNCHRONISE\nSYNCHRONIZE\nREQUESTS\nLOAD\nRESPONSE_INFO\n"
                          "HEADER\nBODY\nWITH\nWITHOUT\nINTO\nTO\nON\nFROM\nBINARY\n"
                          "URI\nURL\nALL\nCANCEL\nRESPONSE\nTIMER\nRETURNING\nSTATUS\n"
                          "CODE\nTIMEOUT\nGOTO\nPRIMARY\n\0");

    AddKeywords( pczBuffer ) ;
}

//-----------------------------------------------------------------------

void COSModellerEditCtrl::ReadPreferences()
{
    COSWebEditCtrl::ReadPreferences() ;
}

void COSModellerEditCtrl::SavePreferences()
{
    COSWebEditCtrl::SavePreferences() ;
}



