/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// UrlItemInfo.cpp: implementation of the CRequestInfo class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "RequestInfo.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRequestInfo::CRequestInfo(bool bPrimary, LPCTSTR szUrl,int nConnectionId,int nStartLine,int nEndLine):
	CScriptItemInfo(enRequest,nStartLine,nEndLine),
	m_bPrimary(bPrimary),
	m_strUrl(szUrl),
	m_nConnectionId(nConnectionId)
{
	m_strUrl = m_strUrl.SpanExcluding(" ");
}

CRequestInfo::~CRequestInfo()
{

}

#ifdef _DEBUG
void CRequestInfo::Dump() const
{
	TRACE("Item Type: URL\nURL: %s\nConnection: %d\n%s\n",m_strUrl,m_nConnectionId,m_bPrimary ? "PRIMARY" : "SECONDARY");
	CScriptItemInfo::Dump();
	TRACE("\n");
}
#endif

bool CRequestInfo::IsHtml() const
{
	
	return (m_strUrl.Right(5).CompareNoCase(".html")==0 || 
			m_strUrl.Right(4).CompareNoCase(".htm")==0 );
}