/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// VariableInfo.cpp: implementation of the CVariableInfo class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "VariableInfo.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

	
CVariableInfo::CVariableInfo(VariableType nType,char *szName,int nSize,LPCTSTR szInit,VariableScope nScope,
							 LPCTSTR szFileName,bool bRandom,int nStartLine,int nEndLine):
	CScriptItemInfo(enVariable,nStartLine,nEndLine),
	m_nType(nType),
	m_strName(szName),
	m_nSize(nSize),
	m_strInitialisation(szInit),
	m_nScope(nScope),
	m_strFileName(szFileName),
	m_bRandom(bRandom)
{

}

CVariableInfo::~CVariableInfo()
{

}

#ifdef _DEBUG
void CVariableInfo::Dump() const
{
	CScriptItemInfo::Dump();
	TRACE("\n");
}
#endif

BOOL CVariableInfo::GetFilename(CString& strFilename) const
{
	if(m_strFileName.IsEmpty())
		return false;

	strFilename = m_strFileName;
	return true;
}

void CVariableInfo::GetInitialisationValues(CStringArray& arstrValues)
{
	CString strCopy(m_strInitialisation);
	char *pszToken = strtok(strCopy.GetBuffer(0),", \"");
	while(pszToken)
	{
		arstrValues.Add(pszToken);
		pszToken = strtok(NULL,", \"");
	}
}
