/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// HttpStatsOcxCtl.cpp : Implementation of the CHttpStatsOcxCtrl ActiveX Control class.

#include "stdafx.h"
#include "HttpStatsOcx.h"
#include "HttpStatsOcxCtl.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CHttpStatsOcxCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CHttpStatsOcxCtrl, COleControl)
//{{AFX_MSG_MAP(CHttpStatsOcxCtrl)
ON_WM_CREATE()
ON_WM_SIZE()
//}}AFX_MSG_MAP
ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CHttpStatsOcxCtrl, COleControl)
//{{AFX_DISPATCH_MAP(CHttpStatsOcxCtrl)
DISP_FUNCTION(CHttpStatsOcxCtrl, "LoadStatsFile", LoadStatsFile, VT_BOOL, VTS_BSTR)
DISP_FUNCTION(CHttpStatsOcxCtrl, "ShowFilter", ShowFilter, VT_EMPTY, VTS_NONE)
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CHttpStatsOcxCtrl, COleControl)
//{{AFX_EVENT_MAP(CHttpStatsOcxCtrl)
// NOTE - ClassWizard will add and remove event map entries
//    DO NOT EDIT what you see in these blocks of generated code !
//}}AFX_EVENT_MAP
END_EVENT_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CHttpStatsOcxCtrl, "HTTPSTATSOCX.HttpStatsOcxCtrl.1",
                       0x67240dc, 0x4131, 0x11d4, 0xbd, 0xad, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CHttpStatsOcxCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DHttpStatsOcx =
    {
        0x67240f0, 0x4131, 0x11d4, { 0xbd, 0xad, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 }
    };
const IID BASED_CODE IID_DHttpStatsOcxEvents =
    {
        0x67240f1, 0x4131, 0x11d4, { 0xbd, 0xad, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 }
    };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwHttpStatsOcxOleMisc =
    OLEMISC_ACTIVATEWHENVISIBLE |
    OLEMISC_SETCLIENTSITEFIRST |
    OLEMISC_INSIDEOUT |
    OLEMISC_CANTLINKINSIDE |
    OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CHttpStatsOcxCtrl, IDS_HTTPSTATSOCX, _dwHttpStatsOcxOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl::CHttpStatsOcxCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CHttpStatsOcxCtrl

BOOL CHttpStatsOcxCtrl::CHttpStatsOcxCtrlFactory::UpdateRegistry(BOOL bRegister)
{
    // TODO: Verify that your control follows apartment-model threading rules.
    // Refer to MFC TechNote 64 for more information.
    // If your control does not conform to the apartment-model rules, then
    // you must modify the code below, changing the 6th parameter from
    // afxRegApartmentThreading to 0.

    if (bRegister)
        return AfxOleRegisterControlClass(
                   AfxGetInstanceHandle(),
                   m_clsid,
                   m_lpszProgID,
                   IDS_HTTPSTATSOCX,
                   IDB_HTTPSTATSOCX,
                   afxRegApartmentThreading,
                   _dwHttpStatsOcxOleMisc,
                   _tlid,
                   _wVerMajor,
                   _wVerMinor);
    else
        return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl::CHttpStatsOcxCtrl - Constructor

CHttpStatsOcxCtrl::CHttpStatsOcxCtrl()
{
    InitializeIIDs(&IID_DHttpStatsOcx, &IID_DHttpStatsOcxEvents);

    // TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl::~CHttpStatsOcxCtrl - Destructor


CHttpStatsOcxCtrl::~CHttpStatsOcxCtrl()
{
    // TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl::OnDraw - Drawing function


void CHttpStatsOcxCtrl::OnDraw(
    CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    if(!m_dlgHttpStats.GetSafeHwnd())
    {
        pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
        pdc->TextOut(10,10,"Http Stats Ocx");
    }
}

/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl::OnResetState - Reset control to default state

void CHttpStatsOcxCtrl::OnResetState()
{
    COleControl::OnResetState();  // Resets defaults found in DoPropExchange

    // TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl message handlers


BOOL CHttpStatsOcxCtrl::LoadStatsFile(LPCTSTR strPath)
{
    if(m_dlgHttpStats.GetSafeHwnd())
        m_dlgHttpStats.LoadFile(strPath);

    return TRUE;
}


int CHttpStatsOcxCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
    if (COleControl::OnCreate(lpCreateStruct) == -1)
        return -1;

    if(!m_dlgHttpStats.Create(IDD_HTTPSTATS_DIALOG,this))
        return -1;

    return 0;
}

void CHttpStatsOcxCtrl::OnSize(UINT nType, int cx, int cy)
{
    COleControl::OnSize(nType, cx, cy);

    if(m_dlgHttpStats.GetSafeHwnd())
        m_dlgHttpStats.MoveWindow(0,0,cx,cy);
}

void CHttpStatsOcxCtrl::ShowFilter()
{
    m_dlgHttpStats.ShowFilter();
}

BOOL CHttpStatsOcxCtrl::OnEraseBkgnd(CDC *pDC)
{
    return true;
}
